import 'package:hydrated_bloc/hydrated_bloc.dart';

class BottomNavCubit extends HydratedCubit<int> {
  BottomNavCubit() : super(0);

  int pagesCount = 4;

  void updateIndex(int index) {
    if (isIndexAllowed(index)) {
      emit(index);
    } else {
      goToHomePage();
    }
  }

  bool isIndexAllowed(int index) {
    return (index >= 0) && (index < pagesCount);
  }

  void goToHomePage() => emit(0);

  @override
  int? fromJson(Map<String, dynamic> json) {
    return json['pageIndex'] as int?;
  }

  @override
  Map<String, dynamic>? toJson(int state) {
    return <String, int>{'pageIndex': state};
  }
}
